#!/usr/bin/awk -f
function getkey(    dd_cmd, key) {
	# ddコマンドを使って、押されたキーを取得する
	dd_cmd = "dd bs=1 count=1 2>/dev/null"
	dd_cmd | getline key
	close(dd_cmd)    # 1キー取得したらcloseする
	return  key
}

BEGIN {
	system("stty raw -echo")    # 端末のバッファリングとエコーをOFFにする

	for ( ; ; ) {
		key = getkey()          # 押されたキーを取得

		# 見えない文字の場合は、ここで文字列に変換する
		if (key == "\n" || key == "\r")
			key = "Enter"
		else if (key == " ")
			key = "Space"
		else if (key == "\t")
			key = "Tab"
		else if (key == "\033")
			key = "Escape"

		print "You hit [", key, "]."    # 押されたキーを表示
		printf "\r"    # 端末の設定を変えているので、カーソルを行頭に戻すために\rを出力

		if (key == "q") exit 0    # 押されたキーが'q'なら終了
	}
}

END {
	# 終了前に端末の設定を元に戻す(バッファリングとエコーをONにする)
	system("stty cooked echo")
	print "exit..."
}
